#ifndef __BinaryLoader_H__
#define __BinaryLoader_H__

// note use forward declaration instead
#include <string>
#include <iostream>
#include <fstream>
#include <map>

#include "common.h"


namespace CHCDemo
{

class igzstream;
class SceneEntity;
class Material;
class Geometry;
class Texture;


class BinaryLoader
{
public:

	bool Load(const std::string &filename, SceneEntityContainer &geometry);

protected:
	
	void LoadTextures(std::ifstream &str);

	SceneEntity *LoadSceneEntity(std::ifstream &str);
	Material *LoadMaterial(std::ifstream &str);
	Geometry *LoadGeometry(std::ifstream &str);

	/*SceneEntity *LoadShape(igzstream &str);
	Material *LoadMaterial(igzstream &str);
	Geometry *LoadGeometry(igzstream &str);
	*/

	std::map<int, Texture *> mTextureTable;
};

}
#endif
